Bug 800134 - Bugs found in python-GeoIP-1.2.5-0.4.20090931cvs.fc15 using gcc-with-cpychecker static analyzer
Bugs found in python-GeoIP-1.2.5-0.4.20090931cvs.fc15 using gcc-with-cpycheck...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: python-GeoIP (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Matt Domsch
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-03-05 14:50 EST by Dave Malcolm
Modified: 2013-11-17 02:05 EST (History)
1 user (show)

See Also:
Fixed In Version: python-GeoIP-1.2.8-1.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-05-09 14:39:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-03-05 14:50:42 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
python-GeoIP-1.2.5-0.4.20090931cvs.fc15.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-03-05/python-GeoIP-1.2.5-0.4.20090931cvs.fc15/

I've manually reviewed the issues reported by the tool.

Within the category "Reference leaks" the 2 issues reported appear to be genuine leaks; the error-handling paths appear to need a: Py_DECREF(GeoIP)

Within the category "Segfaults within error-handling paths" the 12 issues reported appear to be genuine bugs that could occur under low-memory conditions (where an allocation fails, returning NULL).

Within the category "Returning (PyObject*)NULL without setting an exception" the 1 issue reported may or may not be a real bug, depending on whether GeoIP_range_by_ip() sets the thread's exception status when it returns NULL.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
python-GeoIP-1.2.5-0.4.20090931cvs.fc15
gcc-python-plugin post-0.9 git 11462291a66c8db693c8884cb84b795bb5988ffb running the checker in an *f16* chroot
Comment 1 Fedora Admin XMLRPC Client 2013-03-07 14:17:50 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 2 Matt Domsch 2013-03-07 21:14:02 EST
Dave, where is the /test.py script referenced in the gcc invocation?

I built the latest version of this package into rawhide today.  I'd like to see if it fails in a way similar to the bugs you note here, before it gets too far into F19's release process.  Perhaps you can re-run your check based on rawhide tomorrow?

Thanks,
Matt
Comment 3 Matt Domsch 2013-03-07 23:21:36 EST
reported to support@maxmind.com.
Comment 4 Fedora End Of Life 2013-04-03 12:05:19 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 5 Matt Domsch 2013-05-09 14:39:50 EDT
python-GeoIP-1.2.8-1.fc20 and .fc19 built now, which includes changes made by upstream after I submitted this bug report to them.

Dave, can you re-run your test against this version please?

Closing for now - Dave can reopen if issues still exist.
Comment 6 Fedora Update System 2013-05-09 14:44:14 EDT
python-GeoIP-1.2.8-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-GeoIP-1.2.8-1.fc19
Comment 7 Fedora Update System 2013-11-17 02:05:02 EST
python-GeoIP-1.2.8-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.